package eu.jonahbauer.chat.bot.api;

import com.google.gson.annotations.SerializedName;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.LocalDateTime;


public sealed interface Message {
    Ping PING = new Ping();

    record Ping() implements Message { }

    record Pong() implements Message { }

    record Ack() implements Message { }

    record Post(
            long id,
            @NotNull String name,
            @NotNull String message,
            @NotNull String channel,
            @NotNull LocalDateTime date,
            @Nullable Long delay,
            @SerializedName("user_id")
            @Nullable Long userId,
            @SerializedName("username")
            @Nullable String userName,
            @NotNull String color,
            int bottag
    ) implements Message {
        public boolean bot() {
            return bottag != 0;
        }
    }
}
