package eu.jonahbauer.chat.bot.database.impl;

import org.jetbrains.annotations.NotNull;

abstract class AbstractFactory<F> extends ClassValue<F> {

    @Override
    protected final @NotNull F computeValue(Class<?> type) {
        if (!type.isRecord()) throw new IllegalArgumentException();
        return bridge(type);
    }

    @SuppressWarnings("unchecked")
    private <T extends Record> @NotNull F bridge(@NotNull Class<?> type) {
        return computeValue0((Class<T>) type);
    }

    protected abstract <T extends Record> @NotNull F computeValue0(@NotNull Class<T> type);
}
