package eu.jonahbauer.chat.bot.database.impl;

import org.jetbrains.annotations.NotNull;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;

public interface Preparer<T extends Record> {

    @SuppressWarnings("unchecked")
    static <T extends Record> @NotNull Preparer<T> get(@NotNull Class<T> type) {
        return (Preparer<T>) PreparerFactory.INSTANCE.get(type);
    }

    default void prepare(@NotNull PreparedStatement statement, @NotNull T entity) throws SQLException {
        prepare(statement, entity, 1);
    }

    void prepare(@NotNull PreparedStatement statement, @NotNull T entity, int index) throws SQLException;

    @NotNull List<@NotNull String> columns();
}
